//
//  CustomView.m
//
//  Code generated using QuartzCode on 8/11/14.
//  www.quartzcodeapp.com
//

#import "CustomView.h"
#import "QCMethod.h"

@interface CustomView ()

@property (nonatomic, strong) CAShapeLayer *oval;

@end

@implementation CustomView

- (instancetype)initWithFrame:(CGRect)frame
{
	self = [super initWithFrame:frame];
	if (self) {
		[self setupLayers];
	}
	return self;
}

- (instancetype)initWithCoder:(NSCoder *)coder
{
	self = [super initWithCoder:coder];
	if (self) {
		[self setupLayers];
	}
	return self;
}


- (void)setupLayers{
	CAReplicatorLayer * replicator = [CAReplicatorLayer layer];
	replicator.frame             = CGRectMake(75, 198, 170, 170);
	replicator.instanceCount     = 12;
	replicator.instanceDelay     = 0.1;
	replicator.instanceColor     = [UIColor colorWithRed:1 green: 1 blue:1 alpha:1].CGColor;
	replicator.instanceTransform = CATransform3DMakeRotation(30 * M_PI/180, 0, 0, -1);
	[self.layer addSublayer:replicator];
	{
		CAShapeLayer * oval = [CAShapeLayer layer];
		oval.frame     = CGRectMake(71.05, 0, 27.9, 27.9);
		oval.lineJoin  = kCALineJoinRound;
		oval.fillColor = [UIColor colorWithRed:0.0997 green: 0.471 blue:0.922 alpha:1].CGColor;
		oval.lineWidth = 0;
		oval.path      = [self ovalPath].CGPath;
		[replicator addSublayer:oval];
		_oval = oval;
		
	}
	
}


- (IBAction)startAllAnimations:(id)sender{
	
	[self.oval addAnimation:[self ovalAnimation] forKey:@"ovalAnimation"];
	[QCMethod updateValueFromAnimationsForLayers:@[self.oval]];
}

- (CAAnimationGroup*)ovalAnimation{
	CABasicAnimation * opacityAnim = [CABasicAnimation animationWithKeyPath:@"opacity"];
	opacityAnim.fromValue          = @1;
	opacityAnim.toValue            = @0;
	opacityAnim.duration           = 1.2;
	opacityAnim.timingFunction     = [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionDefault];
	
	CABasicAnimation * transformAnim = [CABasicAnimation animationWithKeyPath:@"transform"];
	transformAnim.fromValue          = [NSValue valueWithCATransform3D:CATransform3DIdentity];;
	transformAnim.toValue            = [NSValue valueWithCATransform3D:CATransform3DMakeScale(0.1, 0.1, 1)];;
	transformAnim.duration           = 1.2;
	transformAnim.timingFunction     = [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionDefault];
	
	CABasicAnimation * fillColorAnim = [CABasicAnimation animationWithKeyPath:@"fillColor"];
	fillColorAnim.fromValue          = (id)[UIColor colorWithRed:0.0997 green: 0.471 blue:0.922 alpha:1].CGColor;
	fillColorAnim.toValue            = (id)[UIColor colorWithRed:0.442 green: 0.785 blue:0.895 alpha:1].CGColor;
	fillColorAnim.duration           = 1.2;
	fillColorAnim.timingFunction     = [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionDefault];
	
	CAAnimationGroup *ovalAnimGroup = [CAAnimationGroup animation];
	ovalAnimGroup.animations        = @[opacityAnim, transformAnim, fillColorAnim];
	[ovalAnimGroup.animations setValue:kCAFillModeBoth forKeyPath:@"fillMode"];
	ovalAnimGroup.duration = [QCMethod maxDurationFromAnimations:ovalAnimGroup.animations];
	ovalAnimGroup.repeatCount = INFINITY;
	
	return ovalAnimGroup;
}

#pragma mark - Bezier Path

- (UIBezierPath*)ovalPath{
	UIBezierPath*  ovalPath = [UIBezierPath bezierPathWithOvalInRect:CGRectMake(0, 0, 28, 28)];
	return ovalPath;
}

@end