//
//  CustomView.swift
//
//  Code generated using QuartzCode on 8/11/14.
//  www.quartzcodeapp.com
//

import UIKit

class CustomView: UIView {
	var oval : CAShapeLayer!
	
	override init(frame: CGRect) {
		super.init(frame: frame)
		setupLayers()
	}
	
	required init(coder aDecoder: NSCoder)
	{
		super.init(coder: aDecoder)
		setupLayers()
	}
	
	func setupLayers(){
		var replicator = CAReplicatorLayer()
		replicator.frame             = CGRectMake(75, 198, 170, 170)
		replicator.instanceCount     = 12
		replicator.instanceDelay     = 0.1
		replicator.instanceColor     = UIColor(red:1, green: 1, blue:1, alpha:1).CGColor
		replicator.instanceTransform = CATransform3DMakeRotation(30 * CGFloat(M_PI/180), 0, 0, -1)
		self.layer.addSublayer(replicator)
		
		oval = CAShapeLayer()
		oval.frame     = CGRectMake(71.05, 0, 27.9, 27.9)
		oval.lineJoin  = kCALineJoinRound
		oval.fillColor = UIColor(red:0.0997, green: 0.471, blue:0.922, alpha:1).CGColor
		oval.lineWidth = 0
		oval.path      = ovalPath().CGPath;
		replicator.addSublayer(oval)
	}
	
	
	@IBAction func startAllAnimations(sender: AnyObject!){
		
		oval?.addAnimation(ovalAnimation(), forKey:"ovalAnimation")
		QCMethod.updateValueFromAnimationsForLayers([oval])
	}
	
	func ovalAnimation() -> CAAnimationGroup{
		var opacityAnim            = CABasicAnimation(keyPath:"opacity")
		opacityAnim.fromValue      = 1;
		opacityAnim.toValue        = 0;
		opacityAnim.duration       = 1.2
		opacityAnim.timingFunction = CAMediaTimingFunction(name:kCAMediaTimingFunctionDefault)
		
		var transformAnim            = CABasicAnimation(keyPath:"transform")
		transformAnim.fromValue      = NSValue(CATransform3D: CATransform3DIdentity);
		transformAnim.toValue        = NSValue(CATransform3D: CATransform3DMakeScale(0.1, 0.1, 1));
		transformAnim.duration       = 1.2
		transformAnim.timingFunction = CAMediaTimingFunction(name:kCAMediaTimingFunctionDefault)
		
		var fillColorAnim            = CABasicAnimation(keyPath:"fillColor")
		fillColorAnim.fromValue      = UIColor(red:0.0997, green: 0.471, blue:0.922, alpha:1).CGColor;
		fillColorAnim.toValue        = UIColor(red:0.442, green: 0.785, blue:0.895, alpha:1).CGColor;
		fillColorAnim.duration       = 1.2
		fillColorAnim.timingFunction = CAMediaTimingFunction(name:kCAMediaTimingFunctionDefault)
		
		var ovalAnimGroup        = CAAnimationGroup()
		ovalAnimGroup.animations = [opacityAnim, transformAnim, fillColorAnim]
		ovalAnimGroup.animations.map{$0.setValue(kCAFillModeBoth, forKeyPath:"fillMode")}
		ovalAnimGroup.duration = QCMethod.maxDurationFromAnimations(ovalAnimGroup.animations as [CAAnimation])
		ovalAnimGroup.repeatCount = Float.infinity
		
		return ovalAnimGroup;
	}
	
	//MARK: - Bezier Path
	
	func ovalPath() -> UIBezierPath{
		var ovalPath = UIBezierPath(ovalInRect: CGRectMake(0, 0, 28, 28))
		return ovalPath;
	}

}